#if !defined(__casort_h)
#define __casort_h

#include "transmt.h"
#include "wcache.h"
#include "occblock.h"

class CCacheSorter : public CTransmission<CSimpleOcc, COccBlock>
{
private:
    static const int DefaultTargetBlockSize;
public:
    CCacheSorter(CReporter *aReporter,
		CInQueue &aInQueue,
		COutQueue &aOutQueue,
		int aTargetBlockSize = DefaultTargetBlockSize);
    virtual ~CCacheSorter();

protected:
	virtual short IsFilled();
	virtual short GetPerc();
	virtual void SetIn(CSimpleOcc *InOcc);
	virtual COccBlock *NewOut();

private:
     CWordCache WordCache;
	COccBlock *OccBlock;
     const int TargetBlockSize;

     void FillBlock(COccBlock *OutBlock);
};

#endif
