#if !defined(__occmap_h)
#define __occmap_h

#include "arrays.h"
#include "mape.h"

#include "cocc.h"
#include "socc.h"

class CAbstractStemmer;

class COccBlock : private DMap<DString,  COccCol>
{
public:
    COccBlock(int aSize);
    virtual ~COccBlock();

    void SetIn(CSimpleOcc *InSimpleOcc,
        CAbstractStemmer *Stemmer);
	// responsible for deleting SimpleOcc

    int IsEmpty() const;
    int GetCount() const;
    int HasBigCol() const { return BigCol; }

    CComposedOcc *NewComposedOcc();

private:
    static const int OccColMax;

    int Emptying;
    int PhaseCount;
    DMap<DString, COccCol>::iterator Itr;
    int BigCol;
    int AliasCount;

    void AddToOld(COccCol &OldCol, ulong Data);
};

#endif
