#if !defined(__lockptr_h)
#define __lockptr_h

//#include <stdio.h>

#include "tltype.h"

class CLockedPtr
{
private:
	CTree *Tree;
	CNode *Ptr;

	// this is private because it's forbidden
	CLockedPtr &operator = (CLockedPtr &Src) { return Src; }
public:
	CLockedPtr(CNode *aPtr, CTree *aTree);
	virtual ~CLockedPtr();

	operator CNode *() { return Ptr; }
	CNode *operator->();
	CNode *operator = (CNode *Src);
	CNode *Drop() { CNode *Q = Ptr; Ptr = 0; return Q; }
};

CItem **AllocInfo();
void FreeInfo(CItem **Info);

class CInfoPtr
{
private:
	CItem **Ptr;

	// this is private because it's forbidden
	CInfoPtr &operator = (CInfoPtr &Src) { return Src; }
public:
	CInfoPtr(CItem **aPtr);
	virtual ~CInfoPtr();

	operator CItem **() { return Ptr; }
	CItem **operator = (CItem **Src);
	CItem **Drop() { CItem **Q = Ptr; Ptr = 0; return Q; }
};

#endif
